# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from .. import _inputs as _root_inputs
from .. import outputs as _root_outputs
from ._enums import *
from ._inputs import *

__all__ = ['TopicRuleArgs', 'TopicRule']

@pulumi.input_type
class TopicRuleArgs:
    def __init__(__self__, *,
                 topic_rule_payload: pulumi.Input['TopicRulePayloadArgs'],
                 rule_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]] = None):
        """
        The set of arguments for constructing a TopicRule resource.
        :param pulumi.Input['TopicRulePayloadArgs'] topic_rule_payload: The rule payload.
        :param pulumi.Input[str] rule_name: The name of the rule.
               
               *Pattern* : `^[a-zA-Z0-9_]+$`
        :param pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]] tags: Metadata which can be used to manage the topic rule.
               
               > For URI Request parameters use format: ...key1=value1&key2=value2...
               > 
               > For the CLI command-line parameter use format: --tags "key1=value1&key2=value2..."
               > 
               > For the cli-input-json file use format: "tags": "key1=value1&key2=value2..."
        """
        pulumi.set(__self__, "topic_rule_payload", topic_rule_payload)
        if rule_name is not None:
            pulumi.set(__self__, "rule_name", rule_name)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="topicRulePayload")
    def topic_rule_payload(self) -> pulumi.Input['TopicRulePayloadArgs']:
        """
        The rule payload.
        """
        return pulumi.get(self, "topic_rule_payload")

    @topic_rule_payload.setter
    def topic_rule_payload(self, value: pulumi.Input['TopicRulePayloadArgs']):
        pulumi.set(self, "topic_rule_payload", value)

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the rule.

        *Pattern* : `^[a-zA-Z0-9_]+$`
        """
        return pulumi.get(self, "rule_name")

    @rule_name.setter
    def rule_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_name", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]:
        """
        Metadata which can be used to manage the topic rule.

        > For URI Request parameters use format: ...key1=value1&key2=value2...
        > 
        > For the CLI command-line parameter use format: --tags "key1=value1&key2=value2..."
        > 
        > For the cli-input-json file use format: "tags": "key1=value1&key2=value2..."
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['_root_inputs.TagArgs']]]]):
        pulumi.set(self, "tags", value)


class TopicRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['_root_inputs.TagArgs']]]]] = None,
                 topic_rule_payload: Optional[pulumi.Input[pulumi.InputType['TopicRulePayloadArgs']]] = None,
                 __props__=None):
        """
        Resource Type definition for AWS::IoT::TopicRule

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] rule_name: The name of the rule.
               
               *Pattern* : `^[a-zA-Z0-9_]+$`
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['_root_inputs.TagArgs']]]] tags: Metadata which can be used to manage the topic rule.
               
               > For URI Request parameters use format: ...key1=value1&key2=value2...
               > 
               > For the CLI command-line parameter use format: --tags "key1=value1&key2=value2..."
               > 
               > For the cli-input-json file use format: "tags": "key1=value1&key2=value2..."
        :param pulumi.Input[pulumi.InputType['TopicRulePayloadArgs']] topic_rule_payload: The rule payload.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TopicRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Resource Type definition for AWS::IoT::TopicRule

        :param str resource_name: The name of the resource.
        :param TopicRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TopicRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 rule_name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['_root_inputs.TagArgs']]]]] = None,
                 topic_rule_payload: Optional[pulumi.Input[pulumi.InputType['TopicRulePayloadArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TopicRuleArgs.__new__(TopicRuleArgs)

            __props__.__dict__["rule_name"] = rule_name
            __props__.__dict__["tags"] = tags
            if topic_rule_payload is None and not opts.urn:
                raise TypeError("Missing required property 'topic_rule_payload'")
            __props__.__dict__["topic_rule_payload"] = topic_rule_payload
            __props__.__dict__["arn"] = None
        replace_on_changes = pulumi.ResourceOptions(replace_on_changes=["ruleName"])
        opts = pulumi.ResourceOptions.merge(opts, replace_on_changes)
        super(TopicRule, __self__).__init__(
            'aws-native:iot:TopicRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'TopicRule':
        """
        Get an existing TopicRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = TopicRuleArgs.__new__(TopicRuleArgs)

        __props__.__dict__["arn"] = None
        __props__.__dict__["rule_name"] = None
        __props__.__dict__["tags"] = None
        __props__.__dict__["topic_rule_payload"] = None
        return TopicRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def arn(self) -> pulumi.Output[str]:
        """
        The Amazon Resource Name (ARN) of the AWS IoT rule, such as `arn:aws:iot:us-east-2:123456789012:rule/MyIoTRule` .
        """
        return pulumi.get(self, "arn")

    @property
    @pulumi.getter(name="ruleName")
    def rule_name(self) -> pulumi.Output[Optional[str]]:
        """
        The name of the rule.

        *Pattern* : `^[a-zA-Z0-9_]+$`
        """
        return pulumi.get(self, "rule_name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['_root_outputs.Tag']]]:
        """
        Metadata which can be used to manage the topic rule.

        > For URI Request parameters use format: ...key1=value1&key2=value2...
        > 
        > For the CLI command-line parameter use format: --tags "key1=value1&key2=value2..."
        > 
        > For the cli-input-json file use format: "tags": "key1=value1&key2=value2..."
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="topicRulePayload")
    def topic_rule_payload(self) -> pulumi.Output['outputs.TopicRulePayload']:
        """
        The rule payload.
        """
        return pulumi.get(self, "topic_rule_payload")

